-- ¡Gracias por explorar el Generador de Contraseñas en Jieshuo! Antes de usar, considera suscribirte a 'Tutoriales para Ciegos' para un tutorial detallado. Busca en YouTube: "Descubre el Poder del Generador de Contraseñas en Jieshuo: Solución para Crear Contraseñas Seguras".
require "import"
import "android.content.Context"
import "android.content.DialogInterface"
import "android.content.Intent"
import "android.widget.Button"
import "android.widget.CheckBox"
import "android.widget.EditText"
import "android.widget.LinearLayout"
import "android.widget.TextView"
import "com.androlua.LuaDialog"
import "android.os.Vibrator"

local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(100)

local passwordGeneratorLayout = {
    LinearLayout;
    orientation = "vertical";
    {
        TextView;
        text = "Longitud de la contraseña:";
    };
    {
        EditText;
        hint = "Ingrese aquí la longitud deseada de la contraseña";
        id = "passwordLengthEdit";
        inputType = "numberDecimal";
    };
    {
        CheckBox;
        text = "Letras mayúsculas en inglés";
        id = "includeUppercaseCheckbox";
    };
    {
        CheckBox;
        text = "Letras minúsculas en inglés";
        id = "includeLowercaseCheckbox";
    };
    {
        CheckBox;
        text = "Números";
        id = "includeNumbersCheckbox";
    };
    {
        CheckBox;
        text = "Caracteres especiales";
        id = "includeSpecialCharsCheckbox";
    };
    {
        CheckBox;
        text = "Copiar contraseña al portapapeles";
        id = "copyPasswordCheckbox";
    };
    {
        CheckBox;
        text = "Guardar contraseña en favoritos";
        id = "saveToFavoritesCheckbox";
    };
    {
        CheckBox;
        text = "Compartir contraseña";
        id = "sharePasswordCheckbox";
    };
    {
        Button;
        text = "CREAR CONTRASEÑA";
        onClick = function()
            local passwordLength = tonumber(passwordLengthEdit.text)
            local includeUppercase = includeUppercaseCheckbox.isChecked()
            local includeLowercase = includeLowercaseCheckbox.isChecked()
            local includeNumbers = includeNumbersCheckbox.isChecked()
            local includeSpecialChars = includeSpecialCharsCheckbox.isChecked()
            local copyPassword = copyPasswordCheckbox.isChecked()
            local saveToFavorites = saveToFavoritesCheckbox.isChecked()
            local sharePassword = sharePasswordCheckbox.isChecked()

            if passwordLength then
                local chars = ""
                if includeUppercase then
                    chars = chars .. "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                end
                if includeLowercase then
                    chars = chars .. "abcdefghijklmnopqrstuvwxyz"
                end
                if includeNumbers then
                    chars = chars .. "0123456789"
                end
                if includeSpecialChars then
                    chars = chars .. "!?@#$%*_=()"
                end

                if chars == "" then
                    service.asyncSpeak("Por favor, elija al menos un símbolo de las opciones proporcionadas para crear la contraseña")
                    vibrator.vibrate(200)
                else
                    local password = ""
                    for i = 1, passwordLength do
                        local randomIndex = math.random(1, #chars)
                        password = password .. chars:sub(randomIndex, randomIndex)
end
service.sendText(password)
service.asyncSpeak("Tu contraseña aleatoria: " .. password)
vibrator.vibrate(150)
if copyPassword then
    service.copy(password)
end
if saveToFavorites then
    service.addFavorites(password)
end
if sharePassword then
    local intent = Intent(Intent.ACTION_SEND)
    intent.setType("text/plain")
    intent.putExtra(Intent.EXTRA_TEXT, password)
    service.startActivity(Intent.createChooser(intent, "Compartir contraseña con:"))
end
dlg.dismiss()
end
else
    service.asyncSpeak("Por favor, ingresa la longitud de la contraseña")
    vibrator.vibrate(200)
end
end;
};
{
Button;
text = "Salir";
onClick = function()
    dlg.dismiss()
end
};
}

local shouldDismissDialog = false

local DialogInterfaceOnDismissListener = luajava.createProxy("android.content.DialogInterface$OnDismissListener", {
onDismiss = function(dialog)
    if shouldDismissDialog then
        dlg.dismiss()
    else
        shouldDismissDialog = true
    end
end
})

dlg = LuaDialog(this)
dlg.setTitle("Generador de Contraseñas")
dlg.setView(loadlayout(passwordGeneratorLayout))
dlg.setCanceledOnTouchOutside(false)
dlg.setOnDismissListener(DialogInterfaceOnDismissListener)
dlg.show()

return true